#!/usr/bin/python

import sys, os, time

APACHE_LOG_DIR = "/var/log/apache/"
# Maximum open log files
MAX_FILES = 1000
CLOSE_COUNT = max(MAX_FILES/100, 2)

# open files
of = {}
# open file date
oc = {}

while True:
  line = sys.stdin.readline()
  pline = line.split(' ', 1)
  domain = ".".join(pline[0].rsplit('.', 2)[-2:])
  if len(pline)<2:
    break
  if not of.has_key(domain):
    # open file line buffered (1)
    of[domain] = open(APACHE_LOG_DIR+domain+'_log', 'a', 1)
  of[domain].write(pline[1])
  oc[domain] = time.time()
  if len(of) > MAX_FILES:
    old_files = sorted(oc, key=oc.get)[:CLOSE_COUNT]
    #print 'MAX open files reached, closing:', old_files
    for i in old_files:
      of[i].close()
      del of[i]
      del oc[i]
